/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "heavylaser.h"
#include "patcher.h"
#include "xcom.h"


extern void FixedAccuracyCompensation();
extern void StunPopulateMenu();
extern void RangeBasedAccuracy();

typedef struct {
	short x;
	short y;
	short z;
} pos;

#define BURST_SHOTS 8
#define FULL_AUTO_ACCURACY 60
#define FULL_AUTO_TU 80
#define CONTROLLED_BURST_WAYPOINTS 3
#define CONTROLLED_BURST_ACCURACY 80
#define CONTROLLED_BURST_TU 80
#define ENERGY_REQUIRED 50

static int ranged_accuracy=0;
static pos burst_targets[BURST_SHOTS+CONTROLLED_BURST_WAYPOINTS*2-1];
static int burst_numTargets=0;
int firing_hl = 0;

static menu_item *tmp_item;
static short tmp_damagetype;
static short tmp_strength;

typedef struct {
	short bulletVisual;
	short shootSound;
	short impactSound;
	short impactAnimation;
} shot_data;

static void UpdateLightmap()
{
	
	if(*needsToUpdateTerrainLightSources)
	{
		TacticalComputeTerrainLightSources();
	}
	if(*needsToUpdateSoldiersLightSources)
	{
		TacticalComputeSoldiersLightSources();
	}
   
}

static void ApplyDamage()
{
	*currentWeapon_damageType=3;

	if(*Tactical_weaponHasHitSomething)
	{
		DoDamageToShotTile();
	}
	if(*Tactical_weaponHasHitSomeone)
	{

		Tactical_DoDamageToUnit(*impactArmorSide,1);
		if(((*currentDamagedUnit_pUnitPos)[0xa]&2) == 0)
		{
			unitref_dat *unitref=*(unitref_dat **)&(*currentDamagedUnit_pUnitPos)[4];
			if(unitref->Unit_Type == 0xe) //blow up cyberdisc
			{
				short x=*(short *)0x478408;
				short y=*(short *)0x47840a;
				short z=*(short *)0x47840c;
				GenerateExplosion(x,y,z,120,2,6,0);
			}
		}
	}
}


static void FullAutoFire()
{
	pos burst_shots[BURST_SHOTS];

	shot_data *shot_info=(shot_data *)0x46D1F8;

	int TU=(*currentUnit_pUnitRef)->TUs_Current;
	int baseTU=(*currentUnit_pUnitRef)->TUs_Max;

	int finalTU=TU-baseTU*FULL_AUTO_TU/100;
	int finalEU=(*currentUnit_pUnitRef)->EUs_Current-ENERGY_REQUIRED;

	short xs=burst_targets[0].x;
	short ys=burst_targets[0].y;
	short zs=burst_targets[0].z;
	short xe=burst_targets[1].x;
	short ye=burst_targets[1].y;
	short ze=burst_targets[1].z;
	for(int i=0; i<BURST_SHOTS;i++)
	{
		float t=(float)i/(float)(BURST_SHOTS-1);
		short x=(short)(xe*t+(1.0-t)*xs);
		short y=(short)(ye*t+(1.0-t)*ys);
		short z=(short)(ze*t+(1.0-t)*zs);

		burst_shots[i].x=x;
		burst_shots[i].y=y;
		burst_shots[i].z=z;
	}

//0x12 -> obdata id for heavy laser
	*(short *)0x46DE56=shot_info[0x12].impactAnimation;
	*(short *)0x47845C=shot_info[0x12].bulletVisual;
	*(short *)0x4A2854=shot_info[0x12].shootSound;
	*(short *)0x49DB0C=shot_info[0x12].impactSound;

	int y1=*currentUnit_ypos;
	int x1=*currentUnit_xpos;
	firing_hl = 1;
	for(int i=0;i<BURST_SHOTS;i++)
	{
		SetFiringPointOrigin(*currentUnit_pUnitPos);

		int orientation=GetRelativePositioning(y1,x1,burst_shots[i].y/16,burst_shots[i].x/16);
		TryChangeUnitOrientation((int)*currentUnit_pUnitPos,orientation);

		*(short *)0x478400=burst_shots[i].x;//x2
		*(short *)0x478402=burst_shots[i].y;//y2
		*(short *)0x478404=burst_shots[i].z;//z2

		*accuracy=(short)((double)FULL_AUTO_ACCURACY*pow(0.9,i));
//		*accuracy=FULL_AUTO_ACCURACY;

		if(ranged_accuracy)
			RangeBasedAccuracy();
		else
			FixedAccuracyCompensation();

		((void (*)(int))(0x4110E0))(1);
		ApplyDamage();
		UpdateLightmap();

		//stop firing if unit is dead
		if(((*currentUnit_pUnitPos)[0xa]&2) == 0)
			break;
	}
	firing_hl = 0;

	burst_numTargets=0;
	*tactical_mainState=1;
	*mouseCursorId=0;

	(*currentUnit_pUnitRef)->TUs_Current=finalTU;
	(*currentUnit_pUnitRef)->EUs_Current=finalEU;
	
	((void (*)())(0x42DD50))();

	PerformReactionFire();
}

static void ControlledBurstFire()
{
	pos burst_shots[CONTROLLED_BURST_WAYPOINTS*2-1];

	shot_data *shot_info=(shot_data *)0x46D1F8;

	int TU=(*currentUnit_pUnitRef)->TUs_Current;
	int baseTU=(*currentUnit_pUnitRef)->TUs_Max;

	int finalTU=TU-baseTU*CONTROLLED_BURST_TU/100;
	int finalEU=(*currentUnit_pUnitRef)->EUs_Current-ENERGY_REQUIRED;

	short xs=burst_targets[0].x;
	short ys=burst_targets[0].y;
	short zs=burst_targets[0].z;
	short xe=burst_targets[1].x;
	short ye=burst_targets[1].y;
	short ze=burst_targets[1].z;
	for(int i=0;i<CONTROLLED_BURST_WAYPOINTS;i++)
	{
		short xs=burst_targets[i].x;
		short ys=burst_targets[i].y;
		short zs=burst_targets[i].z;
		short xe=burst_targets[i+1].x;
		short ye=burst_targets[i+1].y;
		short ze=burst_targets[i+1].z;

		burst_shots[2*i].x=xs;
		burst_shots[2*i].y=ys;
		burst_shots[2*i].z=zs;

		if(i!=CONTROLLED_BURST_WAYPOINTS-1)
		{
			burst_shots[2*i+1].x=(xs+xe)/2;
			burst_shots[2*i+1].y=(ys+ye)/2;
			burst_shots[2*i+1].z=(zs+ze)/2;
		}
	}

//0x12 -> obdata id for heavy laser
	*(short *)0x46DE56=shot_info[0x12].impactAnimation;
	*(short *)0x47845C=shot_info[0x12].bulletVisual;
	*(short *)0x4A2854=shot_info[0x12].shootSound;
	*(short *)0x49DB0C=shot_info[0x12].impactSound;

	int y1=*currentUnit_ypos;
	int x1=*currentUnit_xpos;

	firing_hl = 1;

	for(int i=0;i<CONTROLLED_BURST_WAYPOINTS*2-1;i++)
	{
		SetFiringPointOrigin(*currentUnit_pUnitPos);

		int orientation=GetRelativePositioning(y1,x1,burst_shots[i].y/16,burst_shots[i].x/16);
		TryChangeUnitOrientation((int)*currentUnit_pUnitPos,orientation);

		*(short *)0x478400=burst_shots[i].x;//x2
		*(short *)0x478402=burst_shots[i].y;//y2
		*(short *)0x478404=burst_shots[i].z;//z2

		*accuracy=CONTROLLED_BURST_ACCURACY;
		
		if(ranged_accuracy)
			RangeBasedAccuracy();
		else
			FixedAccuracyCompensation();

		((void (*)(int))(0x4110E0))(1);
		ApplyDamage();
		UpdateLightmap();
		//stop firing if unit is dead
		if(((*currentUnit_pUnitPos)[0xa]&2) == 0)
			break;
	}
	firing_hl = 0;

	burst_numTargets=0;
	*tactical_mainState=1;
	*mouseCursorId=0;

	(*currentUnit_pUnitRef)->TUs_Current=finalTU;
	(*currentUnit_pUnitRef)->EUs_Current=finalEU;
	
	((void (*)())(0x42DD50))();

	PerformReactionFire();
}

static void FullAutoMode()
{
	//right click -> remove target/leave burst mode
	if(*mouse_num_click2)
	{
		if(burst_numTargets>0)
		{
			burst_numTargets--;
		}
		else
		{
			*tactical_mainState=1;
			*mouseCursorId=0;
		}
	}

	if(*mouse_num_click1)
	{
		//ignore click in status bar
		if(*mouse_ypos>144)
			return;

		unsigned int TU=(*currentUnit_pUnitRef)->TUs_Current;
		unsigned int baseTU=(*currentUnit_pUnitRef)->TUs_Max;
		unsigned int energy=(*currentUnit_pUnitRef)->EUs_Current;

		if(TU<baseTU*FULL_AUTO_TU/100)
		{
			*Tactical_StatusErrorMessage=1;
			return;
		}
		if(energy<ENERGY_REQUIRED)
		{
			*Tactical_StatusErrorMessage=2;
			return;
		}

		burst_targets[burst_numTargets].x=(*tac_currentTile_xpos+*tac_xview)*16+8;
		burst_targets[burst_numTargets].y=(*tac_currentTile_ypos+*tac_yview)*16+8;
		burst_targets[burst_numTargets].z=*tac_zview*24+12;
		burst_numTargets++;

		if(burst_numTargets==2)
		{
			FullAutoFire();
		}
	}
}

static void ControlledBurstMode()
{
	//right click -> remove target/leave burst mode
	if(*mouse_num_click2)
	{
		if(burst_numTargets>0)
		{
			burst_numTargets--;
		}
		else
		{
			*tactical_mainState=1;
			*mouseCursorId=0;
		}
	}

	if(*mouse_num_click1)
	{
		//ignore click in status bar
		if(*mouse_ypos>144)
			return;

		unsigned int TU=(*currentUnit_pUnitRef)->TUs_Current;
		unsigned int baseTU=(*currentUnit_pUnitRef)->TUs_Max;
		unsigned int energy=(*currentUnit_pUnitRef)->EUs_Current;

		if(TU<baseTU*CONTROLLED_BURST_TU/100)
		{
			*Tactical_StatusErrorMessage=1;
			return;
		}
		if(energy<ENERGY_REQUIRED)
		{
			*Tactical_StatusErrorMessage=2;
			return;
		}

		burst_targets[burst_numTargets].x=(*tac_currentTile_xpos+*tac_xview)*16+8;
		burst_targets[burst_numTargets].y=(*tac_currentTile_ypos+*tac_yview)*16+8;
		burst_targets[burst_numTargets].z=*tac_zview*24+12;
		burst_numTargets++;

		if(burst_numTargets==CONTROLLED_BURST_WAYPOINTS)
		{
			ControlledBurstFire();
		}
	}
}

static void DrawWaypoints(int arg0, int arg1, __int16 y, __int16 x, __int16 z)
{
	((void (*)(int arg0, int arg1, int y, int x, int z))(0x425F70))(arg0,arg1,y,x,z);

	if(burst_numTargets>0)
	{
		char *icon=*file_ufograph_cursor_pck+*(*file_ufograph_cursor_tab+7);
		for(int i=0;i<burst_numTargets;i++)
		{
			short xpos=burst_targets[i].x>>4;
			short ypos=burst_targets[i].y>>4;
			short zpos=burst_targets[i].z/24;

			if(xpos==x&&ypos==y&&zpos==z)
			{
				DrawPCKSprite(arg1,arg0,(int)icon,0x20);
			}
		}
	}
}


static __declspec(naked) int SetFullAutoMode()
{
	*tactical_mainState=0x13;
	burst_numTargets=0;
	*mouseCursorId=4;
	__asm
	{
		mov eax,0x41D121
		jmp eax;
	}
} 


static __declspec(naked) int SetControlledBurstMode()
{
	*tactical_mainState=0x14;
	burst_numTargets=0;
	*mouseCursorId=4;
	__asm
	{
		mov eax,0x41D121
		jmp eax;
	}
} 


static void BurstPatchResources()
{
	*(char **)(0x49D660+4*0x20)="Full Auto";
	*(char **)(0x49D660+4*0x21)="Burst Shot";
}

static __declspec(naked) int BurstPopulateMenu()
{
//dl -> itemtype
//di -> weaponstrength
//bx -> damagetype

	__asm
	{
		//heavy laser only
		push edx
		cmp dl,0x12
		jnz skip

		mov tmp_damagetype,bx
		mov tmp_strength,di
	}

	//remove aimed and snap shot
	//(*WeaponMenu_NumEntries)--; //allow snap shot
	(*WeaponMenu_NumEntries)--;

	tmp_item=&WeaponMenu_Items[*WeaponMenu_NumEntries];

	tmp_item->accuracy=CONTROLLED_BURST_ACCURACY;
	//recycle unused "close" action type for controlled burst
	tmp_item->actionType=5;
	tmp_item->damageType=tmp_damagetype;
	tmp_item->TUusage=(*currentUnit_pUnitRef)->TUs_Max*CONTROLLED_BURST_TU/100;
	tmp_item->weaponStrength=tmp_strength;

	*currentWeapon_damage=tmp_strength;
	*currentWeapon_damageType=tmp_damagetype;

	(*WeaponMenu_NumEntries)++;


	tmp_item=&WeaponMenu_Items[*WeaponMenu_NumEntries];

	tmp_item->accuracy=FULL_AUTO_ACCURACY;
	//recycle unused "open" action type for full auto
	tmp_item->actionType=4;
	tmp_item->damageType=tmp_damagetype;
	tmp_item->TUusage=(*currentUnit_pUnitRef)->TUs_Max*FULL_AUTO_TU/100;
	tmp_item->weaponStrength=tmp_strength;

	*currentWeapon_damage=tmp_strength;
	*currentWeapon_damageType=tmp_damagetype;

	(*WeaponMenu_NumEntries)++;
	


	__asm
	{
skip:
		pop edx
		jmp StunPopulateMenu
/*
		pop     edi
		pop     esi
		pop     ebp
		pop     ebx
		add     esp, 0x0C
		retn
*/
	}
}

void ModHeavyLaser()
{
	ranged_accuracy = INI_READ_INT("Range Based Accuracy","Apply",0);

	//Hook tile drawing procedure
	InsertCall(0x4251E7,DrawWaypoints);
	InsertCall(0x425AF8,DrawWaypoints);
	InsertCall(0x425E04,DrawWaypoints);

//041FE37 83 F8 12
	char patch_maxstates[]={0x14};
	PatchInPlace(0x41FE39,patch_maxstates,1);
	
//41FFC4 90 90 90 90
	int patch_newstate=(int)&FullAutoMode;
	PatchInPlace(0x41FFC4,(char *)&patch_newstate,4);
	patch_newstate=(int)&ControlledBurstMode;
	PatchInPlace(0x41FFC8,(char *)&patch_newstate,4);

	InsertJmp(0x41DA59,BurstPopulateMenu);

	int patch_addmode=(int)&SetFullAutoMode;
	PatchInPlace(0x41D168+4*4,(char *)&patch_addmode,4);
	patch_addmode=(int)&SetControlledBurstMode;
	PatchInPlace(0x41D168+4*5,(char *)&patch_addmode,4);

	InsertJmp(0x418D38,BurstPatchResources);
}
